// Copyright 2014 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef V8_COMPILER_LOAD_ELIMINATION_H_
#define V8_COMPILER_LOAD_ELIMINATION_H_

#include "src/compiler/graph-reducer.h"

namespace v8 {
namespace internal {
namespace compiler {

class LoadElimination final : public AdvancedReducer {
 public:
  explicit LoadElimination(Editor* editor) : AdvancedReducer(editor) {}
  ~LoadElimination() final;

  Reduction Reduce(Node* node) final;

 private:
  Reduction ReduceLoadField(Node* node);
};

}  // namespace compiler
}  // namespace internal
}  // namespace v8

#endif  // V8_COMPILER_LOAD_ELIMINATION_H_
