# Node Foundation TSC Meeting 2015-07-15

## Links

* **Audio Recording**: https://soundcloud.com/node-foundation/tsc-meeting-2015-07-15
* **GitHub Issue**: https://github.com/nodejs/node-convergence-archive/issues/67
* **Original Minutes Google Doc**: https://docs.google.com/document/d/1r8boI4E67Cq7PEsYeIpXkFZM0be4Ww5UDlNr_uXOop0

## Agenda

Extracted from **tsc-agenda** labelled issues and pull requests prior to meeting.

### nodejs/io.js

* Intl [#238](https://github.com/nodejs/io.js/issues/238)
* TC39 representation [#2153](https://github.com/nodejs/io.js/issues/2153)

### Other

* Foundation Discussion
* lts: [LTS Proposal](https://github.com/nodejs/LTS#proposed-lts) / Proposal: Release Process [#1997](https://github.com/nodejs/io.js/issues/1997)

## Minutes

### Present

* Mikeal Rogers
* Colin Ihrig (TSC)
* James Snell (TSC)
* Fedor Indutny (TSC)
* Michael Dawson (TSC)
* Steven R Loomis (TSC)
* Alexis Campailla (TSC)
* Jeremiah Senkpiel (TSC)
* Shigeki Ohtsu (TSC)
* Trevor Norris (TSC)
* Domenic Denicola
* Brian White (TSC)
* Angela Brown (Linux F)
* Mike Dolan (Linux F)
* Laura Kempke (Linux F)
* Bert Belder (TSC)

### Review of the previous meeting

* Default Unhandled Rejection Detection Behavior [#830](https://github.com/nodejs/io.js/issues/830)
* Adding a "mentor-available" label [#25618](https://github.com/joyent/node/issues/25618)
* Having more people managing releases for Node.js v0.10.x and v0.12.x
* lts: [LTS Proposal](https://github.com/nodejs/LTS#proposed-lts) / Proposal: Release Process [#1997](https://github.com/nodejs/io.js/issues/1997)

### Standup:

* Steven Loomis: Intl WG - https://github.com/nodejs/io.js/issues/2165
* Mikeal Rogers: Meeting with the Linux Foundation
* Colin Ihrig: Issues & PRs, met with Julien & Sam for joyent/node release onboarding
* James Snell: Deep diving on a couple issues, looking into TC39 involvement, LTS feedback
* Fedor Indutny: some bugs and node-spdy, not too much
* Alexis Campailla: build-related things to converge the CI, most of the work is done, trying to get the CI working for 0.10. Also speeding up arm builds. +Windows issues.
* Jeremiah Senkpiel: CascadiaJS Feedback was positive for the project convergence, sick from the cascadiajs cold, not much else.
* Shigeki Ohtsu: Did the security update for OpenSSL on thursday
* Domenic Denicola: Not much, working on the unhandled rejection spec.
* Brian White: Mostly working on the JS Http parser, also working on a JSPerf.com-like tool for testing different node versions from the browser.

### Foundation Discussion (@mikeal leading)

Security policy best-practices

### Intl [#238](https://github.com/nodejs/io.js/issues/238)

Discussion if we can land this into `master` rather than `next`.

Action: Check that there is no objection to landing in `master`.

Steven, Domenic, James: Should be a direct port from 0.12, we can work on making a PR.

### TC39 representation [#2153](https://github.com/nodejs/io.js/issues/2153)

Discussion about the legalities of joining officially and if unofficial representation would be workable.

Action: Domenic will invite Mikeal to check out one of the TC39 meetings.

### lts: [LTS Proposal](https://github.com/nodejs/LTS#proposed-lts) / Proposal: Release Process [#1997](https://github.com/nodejs/io.js/issues/1997)

Mikeal: We are effectively working under the new release proposal ([#1997](https://github.com/nodejs/io.js/issues/1997)) now with how `next` / 3.0.0 is going.

Jeremiah: Only real contested point is how we might version the `next` branch releases.

Domenic: Having multiple release train versionings in confusing.

Action: Mikeal will update the current PR and separate any contention points into new PRs for discussion.

### Next Meeting

July 22nd 2015
