# Node.js Foundation TSC Meeting 2015-08-12

## Links

* **Audio Recording**: https://soundcloud.com/node-foundation/tsc-meeting-2015-08-12
* **GitHub Issue**: https://github.com/nodejs/node-convergence-archive/issues/71
* **Minutes Google Doc**: https://docs.google.com/document/d/1q2bFjnf0Y23Ljxoze56Pmrbailaj5-UAqIUqIYVhiIk
* _Previous Minutes Google Doc: <https://docs.google.com/document/d/1FBmDczHD4D8jfffc6A8CW-K9mmT0KI8shG6dm_d3jXI>_

## Agenda

Extracted from **tsc-agenda** labelled issues and pull requests prior to meeting.

* Travel assistance amendment (no issue for this)
* FYI: Collaboration WG: https://github.com/nodejs/collaboration  
* Summit recap
* level-set on repo rename
* Future: “project lifecycle” (Mikeal) - process by which top level projects are added (libuv, node-gyp, etc), (conferences…)


## Minutes


### Present

* Mikeal Rogers
* Rod Vagg (TSC)
* James Snell (TSC)
* Michael Dawson (TSC)
* Steven R Loomis (TSC) 
* Chris Dickinson (TSC)
* Alexis Campailla (TSC)
* Brian White (TSC)

### Review of the previous meeting

* Next branch release versioning [#2215](https://github.com/nodejs/io.js/issues/2215)
* TSC Chair - Election? 

### Standup:

* Mikeal: summit, code & learn project for new collab
* Rod: Summit, migrating nodejs/io.js to nodejs/node
* James: convergence, joyent/node PRs
* Michael: patch for AIX, 0.12 work, Benchmarking meeting
* Steven: Summit, 1st Intl meeting, Intl convergence work, VS2015 fixes
* Chris: Summit, Docs repo has taken off, [HTTP lifecycle doc by Bryan English](https://github.com/nodejs/docs/blob/master/src/guides/anatomy-of-an-http-transaction.md)
* Alexis: Summit, progress on CI convergence, reviewed some PRs.
* Brian: Triaging and reviewing PRs and Issues.

### Travel assistance amendment (no issue for this)

* Chris Dickinson adding $500 to the travel expenditure 
* Passed unanimously.

### FYI: Collaboration WG: https://github.com/nodejs/collaboration  

* Steven: new WG coming out of the Summit, Sean (@snostorm) is taking lead on this. One idea under discussion now is to have a multi-timezone meetings for the language working groups.
* Mikeal: is this going to serve as a collaboration point for the language groups?
* Steven: https://github.com/nodejs/Intl/issues/9
* Rod: beyond the language groups, what are the aims of this new group?
* Steven: trying to address, or having a place to discuss, common items across working groups.
* James: filling a need to liaise with the other working groups, acting as an intermediary

### Summit recap

* Mikeal: 6 sessions in 2 days, not solid answers to problems but a shared understanding of the common problems, feels like we are on the same page from that
* Mikeal: bigger sessions: what is the Node API and what is the Node platform? V8 release cycle. Errors and the inconsistencies. Kept coming back to the collaboration WG, which is why it exists. Talked about expanding the collaborator base, idea was to do some collaboration sprints to bring new folks up to speed, https://github.com/nodejs/code-and-learn comes from that idea (there is foundation budget for that).
* Mikeal: there were extensive notes taken, those are being edited now and will be published into the repo(s) and turned into blog posts.

### level-set on repo rename

* James: what are the remaining things to do - there’s confusion around the naming
  - Renaming everything in the documentation (README, docs & other misc docs)
  - Renaming binary
  - Alexis: finishing convergence work
* Mikeal: preparing a blog post about what’s happening, will be reviewed and posted soon

### Future: “project lifecycle” (Mikeal) - process by which top level projects are added (libuv, node-gyp, etc), (conferences…)

* Mikeal: the TSC charter states that we will adopt a project lifecycle that will allow us to bring in other _top level projects_. Additionally, the TSC has had to take on board some non-technical work because of its position in the Foundation (voting on expenditure, etc.), a number of TSC members don’t want to be involved in that kind of activity. Have started drafting a new project lifecycle plan which splits off a “Core TSC” that contains the existing TSC members but with a focus on Node.js Core work while the existing TSC will take on board the higher-level foundation work and members can optionally resign if they aren’t interested in that work and we can expand it to non-Core collaborators. https://github.com/nodejs/TSC/tree/lifecycle 


### Next Meeting

August 19th

