# node-forward TC Meeting 2014-10-15

## Agenda

* Openssl upgrade / openssl 1.0.1j, disabling SSL3 support
* Status of the build system & release automation
* https://github.com/node-forward/node/pull/14 - refine TC percentage rules - CONTRIBUTING.md
* Items preventing node-forward from releasing v0.12.
* Node Forward release cycle/schedule.
* (Maybe discuss v8 3.29 in node-forward vs 3.28 in joyent/node, and merging them? ...just a suggestion) 
* Performance situation
* Node Forward website, non-core stuff, help repo.

## Links

* **Google Hangouts Video**: https://www.youtube.com/watch?v=aRBuu2m5xbI
* **Original Minutes Google Doc**: https://docs.google.com/a/vagg.org/document/d/18l01PO2Rb3OZXWMcIkZ_sU4f1JKP2LKOwjuiENkg37M

## Minutes

### Present

* Rod Vagg (facilitator, build representative)
* Mikeal Rogers (facilitator)
* Ben Noordhuis (TC)
* Bert Belder (TC)
* Fedor Indutny (TC)
* Trevor Norris (TC)

### Discussion

* Fedor: **OpenSSL upgrade to 1.0.1j done in a branch**, build bots reporting OK, ready to merge. SSLv3 disabled completely in joyent/node 0.12 because the protocol is broken--attack comes from downgrade request from TLS to SSLv3. 0.10 has a runtime flag to enable it via process arguments (`--enable-ssl3`).
* Rod (representing the build group): tried Jenkins and BuildBot. Neither are great, but right now they’re working on getting something to work now, although eventually they’d like a great build system. There are build bots running for most platforms right now, except OS X (but there’s commitment from voxer to sponsor machines). Building branches works, but PRs doesn’t. This week some basic useful stuff should be available.
  - https://github.com/graydon/bors - rust
  - Benchmarks? Make a CI target just for benchmarks so we can track it over time. Not run on every PR, perhaps manually triggered, perhaps time triggered. http-simple? Fedor: large nightly benchmarks would be nice. Start with Linux, a single consistent box running the suite (doing a release too).
* **Refine TC percentage**: pull node-forward/node#14. TC is short two people without Joyent & is small. 2 of 6 people are from Strongloop. #14 allows changing to 33% to allow the current TC to not be in violation for the time being and then change it back to 20% when we can. Consensus has been relatively easy, no votes have been needed thus far so there isn’t much concern.
* **Release cycle**: time based releases? node-forward discussion have strong consensus for a desire to move to semver and also a quicker release cycle.
 - **General agreement on semver**, minor releases backward-compatible, major releases can break.
  - Discussion on **native API compatibility**, NAN or NAN-like or something more brave like having ABI compatibility. Ben: “You can’t forecast the future, the abstraction will break”.
  - **Supporting old versions**: deal with it when the project has “prior releases”. Defer discussion on exactly the model until the project is ready to make proper releases. Move discussion to GitHub.
* **V8 3.29**, Fedor: joyent/node has 3.28, node-forward/node has 3.29. Trevor & Fedor agreed to put 3.29 in joyent/node pending agreement with TJ.
* **node-forward website**, Mikeal: there is a website, http://nodeforward.org/ 
  - Forrest suggests a help repo to replace what the mailing list works, he has offered to help support that.

