# io.js TC Meeting 2015-04-15

## Links

* **Public YouTube feed**: http://www.youtube.com/watch?v=lsRu_of0Xp8
* **Google Plus Event page**: https://plus.google.com/events/cdinisa9mlisv81um91h71g3css
* **GitHub Issue**: https://github.com/nodejs/io.js/issues/1431
* **Original Minutes Google Doc**: https://docs.google.com/document/d/1zlYeYS0LCyIjN4KsjXh9d46hNjp302M6L1K_-_OckzQ

## Agenda

Extracted from https://github.com/nodejs/io.js/labels/tc-agenda prior to meeting.

* [#1393](https://github.com/nodejs/io.js/issues/1393) Ready to upgrade to V8 4.2?
* [#1413](https://github.com/nodejs/io.js/issues/1413) combining TC and Node core call
* [#1416](https://github.com/nodejs/io.js/issues/1416) io.js diff node.js foundation

### Present

* Ben (TC)
* Bert (TC)
* Chris (TC)
* Domenic
* Isaac (TC)
* Jeremiah
* Mikeal
* Rod (TC)

### Review of last meeting

* [#1101](https://github.com/nodejs/io.js/pull/1101) http: allow HTTP to return an HTTPS server
* [#1301](https://github.com/nodejs/io.js/pull/1301) Util(.is*) Deprecations
* [Dev Policy](https://github.com/jasnell/dev-policy)
* Isaac
* [#1365](https://github.com/nodejs/io.js/issues/1356) `require('.')`


### Quick stand-up

* Ben: will be working less on io.js in the coming weeks
* Bert: come clang hacking but not much else
* Chris: some review/work on dev-policy
* Domenic: did some review of the URL work
* Isaac: on vacation and busy re fundraising, probably have less time for io.js into the future, will likely be moved out of the role
* Jeremiah: some issue management, working with dev-policy
* Mikeal: dev-policy and readable summary of the foundation documents
* Rod: lots of build WG work including auto Jenkins runs, write-up on “the state of the build”

## Minutes

### [#1393](https://github.com/nodejs/io.js/issues/1393) Ready to upgrade to V8 4.2?

* Ben: `next` branch should be ready to go though needs to be upgraded to 4.2.77.14, C++ changes are fairly minimal.
* Discussed potentially bumping major:
  - Mikeal: there was a meeting where it was generally agreed that an ABI change would warrant a version bump
  - Rod & Isaac suggested that ABI changes shouldn’t bump major
  - Discussion came around to most members agreeing that ABI change _should_ bump major. Rod voted 0 on this, everyone else apparently +1.
  - Discussed semver-major changes including process.send() sync regressions, agreed that https://github.com/nodejs/io.js/milestones/2.0.0 represents the best info on what’s mergable
* Discussed git, agreed that we should move back to master, Chris to handle git changes
* Discussed RC build, could use nightly or next-nightly but officially link it off the website and maybe label it differently. Rod to figure this out.

Actions:
 - Isaac to further review url changes, aside from his review and Domenic’s feedback in there it should be ready to merge
 - Chris to handle git and a move back to master
 - Ben to PR next branch back into master
 - Rod to figure out how to do and publish an RC build that’s not just “nightly-xxxxxxxxxxxxxx”
 - Chris will test packages against URL PR and write up results

### [#1413](https://github.com/nodejs/io.js/issues/1413) combining TC and Node core call

* Mikeal: last dev-policy call brought up the suggestion of combining TC calls for both projects, with an eye on merging it would be good to understand what both groups do. Single meeting for both would be good.
* Discussed timing - we span more timezones than they do so our slot of 1pm PST makes more sense to get Rod and Fedor in at the same time. Could either be Tue or Wed UTC, they have a meeting the day before us.
* No strong disagreement

### [#1416](https://github.com/nodejs/io.js/issues/1416) io.js diff node.js foundation

* Mikeal: Foundation doc is huge compared to ours and also contains some formalisation of our process that we just haven’t formalised yet. The diff contains a lot of those and some _actual_ changes too. Open for discussion amongst the community.
* Rod: LTS discussion starting next week.

## QA on Freenode/#io.js

* Paused for input, nothing this week, will continue to offer a time for this.

## Next meeting

* FluentConf is on next week, Bert, Mikeal and Isaac will be at that. Agreed to go ahead and schedule one anyway.
* 2015-04-22
